=== debian/changelog ===
nng (1.2.6-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 06 Feb 2020 22:41:30 +0000

nng (1.2.5-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 02 Feb 2020 09:30:28 +0000

nng (1.2.4-1) unstable; urgency=medium

  * New upstream release.
  * Link testlib with atomic if needed.
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 21 Jan 2020 16:37:13 +0000

nng (1.2.3-1) unstable; urgency=medium

  * Initial release (closes: #948362).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 06 Jan 2020 22:59:39 +0000
